!+
!KWIC comic.h
!
!Id$
!
!History:
!   1996-Jun-05[T. Gaetz]
!      . moved from individual source files to included file.
!      . reordered:  double precision, real, integer.
!      . add save statement
!
!  DEFINITIONS (extracted from source files):
!
!  /COMIC/ VARIABLES INITIALIZED:
!    XD   : R*8 - X COORD. OF INTERSECTION OF RAY WITH SURFACE
!    YD   : R*8 - Y COORD. OF INTERSECTION OF RAY WITH SURFACE
!    ZD   : R*8 - Z COORD. OF INTERSECTION OF RAY WITH SURFACE
!    XL   : R*8 - DIRECTION COSINE WRT X AXIS
!    YL   : R*8 - DIRECTION COSINE WRT Y AXIS
!    ZL   : R*8 - DIRECTION COSINE WRT Z AXIS
!    XG   : R*8 - X COMPONENT OF GRADIENT OF SURFACE AT (XD,YD,ZD)
!    YG   : R*8 - Y COMPONENT OF GRADIENT OF SURFACE AT (XD,YD,ZD)
!    ZG   : R*8 - Z COMPONENT OF GRADIENT OF SURFACE AT (XD,YD,ZD)
!    PHIL : R*4 - 2/L FOR X-RAY SYSTEM, 1/R2S FOR CONVENTIONAL SYSTEM

      REAL*8         XD, YD, ZD, XL, YL, ZL, XG, YG, ZG, PHIL
      COMMON /COMIC/ XD, YD, ZD, XL, YL, ZL, XG, YG, ZG, PHIL
      SAVE   /COMIC/
