!
!  UPDATED 2/4/88 TO READ ENLARGED GX FILES
!  PAUL GLENN, BAUER ASSOCIATES, INC.
!
      SUBROUTINE RDGX (ND, GEOP, LSW, JER)
C   /******************************************/
C    *
C    *    PERKIN-ELMER CORPORATE COMPUTING
C    *      SOFTWARE ENGINEERING SECTION
C    *
C    *    RDGX FORTRAN
C    *    WRITTEN BY JOHN LEGG
C    *            ON 04/25/80
C    *
C    *    UPDATE:   05/08/81
C    *    TIME:     13:42:29
C    *
C    ******************************************/
C
C  PURPOSE: TO READ THE SYSTEM GEOMETRY INFORMATION AND
C           SURFACE INFORMATION FROM FILE 'GX'
C
C  INPUT:
C    FILE 'GX' ON UNIT # ND
C
C  OUTPUT ARGUMENTS:
C    GEOP : REAL * 8 ARRAY CONTAINING EITHER GENERAL
C           SYSTEM OR SURFACE GEOMETRY PARAMETERS
C    LSW  : LOGICAL * 1 ARRAY CONTAINING THE
C           CORRESPONDING SWITCHES
C    JER  : ERROR CODE
C         :  0 - NO ERROR
C         :  1 - END OF FILE  (EOF) CONDITION
C         :  2 - ERROR WHILE READING FILE
C
      
      !*** ALL REAL*4 VARIABLES HAVE BEEN CHANGED TO REAL*8
      IMPLICIT REAL*8 (A-H,O-Z)
 
!  DIMENSION OF GEOP CHANGED TO 20
      DIMENSION GEOP (20), LSW (10)
      REAL * 8 GEOP
      LOGICAL * 1 LSW
C
      JER = 0
      READ (ND, 100, ERR = 10, END = 20) GEOP, LSW
      GO TO 50
C
10    JER = 2
      GO TO 50
C
20    JER = 1
50    RETURN
! 100   FORMAT (1P,5(4D20.12/), 5X, 5L2, 5X, 5L2)
100   FORMAT (5(4D20.12/), 5X, 5L2, 5X, 5L2)
      END
